﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Data.OleDb;
using System.Web.UI.WebControls;

namespace RestaurantV2
{
    public partial class MakeBooking : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            //Selection changed event for calendar and index changed for drop downlist used, plus list is autopostback
           
        }

        protected void Calendar1_SelectionChanged(object sender, EventArgs e)
        {
            ReadAvailableTables(Calendar1.SelectedDate);
        }

        private void ReadAvailableTables(DateTime checkDate)
        {
            DropDownList1.Items.Clear();    //Clear list
            using (OleDbConnection oConn = new OleDbConnection(@"Provider=Microsoft.ACE.OLEDB.12.0;Data Source=N:\restaurant.accdb"))
            {
                oConn.Open();
                OleDbCommand oCommand = new OleDbCommand("Select t.* from Tables t where t.TableID not in (select b.TableID from Bookings b where b.BookingDate=@date)", oConn);
                oCommand.Parameters.Add(new OleDbParameter("@date", checkDate));
                OleDbDataReader dr = oCommand.ExecuteReader();
                DropDownList1.Items.Add(new ListItem("Select a table", "0"));
                while (dr.Read())
                {
                    DropDownList1.Items.Add(new ListItem(dr.GetString(1), dr.GetInt32(0).ToString()));
                }
                dr.Close();
                oConn.Close();
            }
        }

        protected void DropDownList1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (DropDownList1.SelectedIndex > 0) Button1.Enabled = true; else Button1.Enabled = false;
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            int customerID = (int)Session["userID"];
            int tableID = Convert.ToInt32(DropDownList1.SelectedValue);
            DateTime bookingDate = Calendar1.SelectedDate;

            using (OleDbConnection oConn = new OleDbConnection(@"Provider=Microsoft.ACE.OLEDB.12.0;Data Source=N:\restaurant.accdb"))
            {
                oConn.Open();
                OleDbCommand oCommand = new OleDbCommand("insert into Bookings (CustomerID, TableID, BookingDate) values (@customer, @table, @date)", oConn);
                oCommand.Parameters.Add(new OleDbParameter("@customer", customerID));
                oCommand.Parameters.Add(new OleDbParameter("@table", tableID));
                oCommand.Parameters.Add(new OleDbParameter("@date", bookingDate));
                oCommand.ExecuteNonQuery();
                oConn.Close();
            }
            Response.Redirect("MainPage.aspx");
        }
    }
}